(function() {
  var argon, err, interp, out, root, _;
  var __indexOf = Array.prototype.indexOf || function(item) {
    for (var i = 0, l = this.length; i < l; i++) {
      if (this[i] === item) return i;
    }
    return -1;
  }, __slice = Array.prototype.slice;
  err = (require('err')).instance('argon');
  out = (require('styout')).instance('argon');
  _ = require('underscore');
  err.logByDefault = true;
  argon = {
    ize: function(args, schema) {
      var a, argsLen, callbacks, defaultCallback, event, events, givenOptions, index, key, logSuffix, options, requiredArg, requiredArgs, requiredArgsLen, result, val, _i, _len, _len2, _len3, _ref, _ref2, _ref3, _ref4;
      argsLen = args.length;
      logSuffix = schema.name != null ? " in call to <b>" + schema.name : '';
      if (schema.requiredArgs != null) {
        requiredArgsLen = schema.requiredArgs.length;
        _ref = schema.requiredArgs;
        for (index = 0, _len = _ref.length; index < _len; index++) {
          requiredArg = _ref[index];
          if (index >= argsLen) {
            a = ['Missing required argument', requiredArg];
            throw err('IllegalArgument', out.parse(interp(a) + logSuffix));
          }
        }
        if (argsLen > requiredArgsLen + 1) {
          a = ['Expected', requiredArgsLen, 'to', requiredArgsLen + 1, 'arguments, but got', argsLen];
          throw err('IllegalArgument', out.parse(interp(a) + logSuffix));
        }
        _ref2 = schema.requiredArgs;
        for (index = 0, _len2 = _ref2.length; index < _len2; index++) {
          requiredArg = _ref2[index];
          if (requiredArg.slice(-2) === 's)') {
            if (!(requiredArg instanceof Array)) {
              args[index] = [requiredArg];
            }
          }
        }
      } else {
        requiredArgsLen = 0;
      }
      givenOptions = defaultCallback = null;
      if (argsLen === requiredArgsLen + 1) {
        if (typeof args[argsLen - 1] === 'function') {
          defaultCallback = args[argsLen - 1];
        } else {
          givenOptions = args[argsLen - 1];
        }
      }
      options = (_ref3 = schema.defaultOptions) != null ? _ref3 : {};
      events = (_ref4 = schema.events) != null ? _ref4 : [];
      if (givenOptions) {
        for (key in givenOptions) {
          val = givenOptions[key];
          if (key in options || __indexOf.call(events, key) >= 0) {
            options[key] = val;
          } else {
            out.warn("No such option <b>" + key + "</b>");
          }
        }
      }
      callbacks = {};
      for (_i = 0, _len3 = events.length; _i < _len3; _i++) {
        event = events[_i];
        if (event in options) {
          callbacks[event] = options[event];
          delete options[event];
        } else if (defaultCallback != null) {
          callbacks[event] = defaultCallback;
        } else {
          callbacks[event] = null;
        }
      }
      requiredArgs = Array.prototype.slice.call(args, 0, requiredArgsLen);
      return result = _.extend(__slice.call(requiredArgs).concat([{
          options: options,
          callbacks: callbacks
        }]));
    }
  };
  root = typeof window != "undefined" && window !== null ? window : exports;
  _.extend(root, argon);
  interp = function(strings, useHtml) {
    var index, result, s, _len;
    if (useHtml == null) {
      useHtml = true;
    }
    result = '';
    for (index = 0, _len = strings.length; index < _len; index++) {
      s = strings[index];
      if (index % 2 === 0) {
        result += " " + s;
      } else {
        result += useHtml ? " <b>" + s + "</b>" : " " + s + " ";
      }
    }
    return result;
  };
}).call(this);
